From 8c6890cc56c3418c89c6614158026327f84e3847 Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Thu, 17 Jun 2021 15:12:24 +0200
Subject: [PATCH] theme: add cinor-2021

---
 static/cinor-2021/_custom.scss                | 281 ++++++++++++++++++
 static/cinor-2021/_vars.scss                  |  79 +++++
 static/cinor-2021/config.json                 |  16 +
 static/cinor-2021/style.scss                  |   7 +
 .../combo/page_template_homepage.html         |   9 +
 .../combo/wcs/tracking_code_input.html        |   5 +
 6 files changed, 397 insertions(+)
 create mode 100644 static/cinor-2021/_custom.scss
 create mode 100644 static/cinor-2021/_vars.scss
 create mode 100644 static/cinor-2021/config.json
 create mode 100644 static/cinor-2021/style.scss
 create mode 100644 templates/variants/cinor-2021/combo/page_template_homepage.html
 create mode 100644 templates/variants/cinor-2021/combo/wcs/tracking_code_input.html

diff --git a/static/cinor-2021/_custom.scss b/static/cinor-2021/_custom.scss
new file mode 100644
index 00000000..79d0923c
--- /dev/null
+++ b/static/cinor-2021/_custom.scss
@@ -0,0 +1,281 @@
+.rounded-cell {
+	border-radius: 2rem;
+	overflow: hidden;
+	padding: 1rem;
+}
+
+.green-rounded-cell {
+	@extend .rounded-cell;
+	background-color: $green-blue;
+	color: white;
+
+	input {
+		background-color: white;
+		color: $green-blue-dark;
+	}
+	button {
+		@extend %cancel-button;
+	}
+	a {
+		color: inherit;
+	}
+}
+
+.script-title {
+	font-size: 3em;
+	text-align: center;
+	font-family: $ff-script;
+	text-transform: none;
+	line-height: 1;
+	color: inherit;
+	small {
+		display: block;
+		font-weight: 400;
+		font-family: $ff-ss-serif;
+		font-size: .45em;
+	}
+}
+
+%button {
+	font-weight: 600;
+	text-transform: uppercase;
+	font-size: $fz-small;
+}
+
+%cancel-button {
+	&, &:hover {
+		color: $primary-color;
+		background-color: white;
+		border: 1px solid;
+	}
+	&:hover {
+		color: $button-hover-background;
+	}
+}
+
+// Header
+.site-header {
+	border-top: $topLinks_height solid $primary-color;
+	#top {
+		display: flex;
+		align-items: center;
+		@media ($min-desktop-viewport) {
+			justify-content: center;
+		}
+	}
+	#logo.has-logo {
+		margin-top: -1rem;
+		margin-bottom: 1rem;
+		font-size: 1.5em;
+		@media ($min-desktop-viewport) {
+			// margin-top: 1.5rem;
+			margin-bottom: 1.5rem;
+		}
+		a {
+			padding-top: 1rem;
+			color: $font-color;
+			padding-top: 90px;
+			text-indent: 0 !important;
+			background-size: auto 80px !important;
+			background-position: top left !important;
+			font-family: $ff-script;
+			text-align: left;
+
+			@media ($min-desktop-viewport) {
+				display: flex;
+				align-items: flex-end;
+				padding-left: 250px;
+				height: 100px;
+				background-size: 200px auto !important;
+
+			}
+		}
+	}
+}
+
+// User-info
+#toplinks {
+	// Reset user links
+	border: none;
+	box-shadow: none;
+	border-radius: 0;
+	background-color: transparent;
+	color: white;
+	// position
+	top: auto;
+	bottom: 100%;
+	height: $topLinks_height;
+	padding: 0;
+	line-height: $topLinks_height;
+
+	a {
+		color: inherit;
+		font-size: $fz-small;
+		text-transform: uppercase;
+	}
+
+	// user icon
+	&::before {
+		content: "\f2c0";
+		font-family: fontawesome;
+		margin-right: .33em;
+	}
+}
+
+// Main nav
+div.gru-nav > ul {
+	font-size: $fz-small;
+	margin: 0;
+
+	@media (min-width: $nav-mobile-limit + 1) {
+		text-align: center;
+	}
+
+	li {
+		a {
+			text-transform: uppercase;
+			font-weight: 600;
+		}
+	}
+}
+// Desktop Subnav
+body {
+	border-left: none;
+}
+div.gru-nav > ul ul {
+	@media (min-width: $nav-mobile-limit + 1) {
+		li:hover a {
+			color: $green-yellow;
+		}
+	}
+}
+
+// Mobile nav
+@media (max-width: $nav-mobile-limit) {
+	div.gru-nav .gru-nav-button {
+		top: 0;
+		left: 0;
+	}
+}
+
+// Page picture
+body.has-picture .site-nav::after {
+	position: static;
+}
+
+
+// main
+main {
+	border-top: 1px solid $green-blue;
+	padding-top: 1rem;
+}
+
+
+// Cells
+
+// sidebar cells
+#sidebar {
+	.cell {
+		@extend .green-rounded-cell;
+	}
+	.tracking-code-input-cell {
+		h2:first-child {
+			@extend .script-title;
+
+			& + div {
+				padding: 0;
+			}
+		}
+	}
+}
+
+// Picture position
+.gru-content div.link-list-cell.has-asset-picture,
+.gru-content div.wcsformsofcategorycell.has-asset-picture {
+	> div {
+		display: flex;
+		flex-wrap: wrap;
+		align-items: baseline;
+
+		> * {
+			flex: 0 0 100%;
+		}
+
+		> h2:first-child {
+			flex: 1 0 50%;
+		}
+
+		> picture {
+			display: block;
+			order: -1;
+			flex: 0 0 $title-font-size;
+			align-self: center;
+			margin-left: 1rem;
+
+			img {
+				padding: 0;
+			}
+		}
+	}
+}
+
+// text Cell
+div.text-cell {
+	padding: 1px 1rem;
+	h3, h4, h5, p, table {
+		margin: 1rem 0;
+	}
+}
+
+// WCS
+.gru-content div#tracking-code {
+	@extend .cell;
+	@extend .green-rounded-cell;
+	text-align: center;
+	margin-right: 0;
+	margin-left: 0;
+	padding: 1rem;
+
+	h3 {
+		@extend .script-title;
+		font-size: 2em;
+	}
+	button {
+		margin-right: 0;
+	}
+}
+// Title
+div#rub_service h2 {
+	font-size: 2.5em;
+	padding-left: 0;
+
+	@media (max-width: $very-small-limit) {
+		font-size: 1.5em;
+	}
+}
+// wcs buttons
+div#rub_service .buttons {
+	.submit-button button::after {
+		content: ">";
+		content: ">" / "";
+		margin-left: .66em;
+	}
+	.previous-button button::before {
+		content: "<";
+		content: "<" / "";
+		margin-right: .66em;
+	}
+}
+
+
+// Authentic
+#registration-blocks > .a2-block,
+#login-page > .block {
+	background: transparent;
+}
+
+// Footer
+#footer a {
+	color: white;
+}
+
diff --git a/static/cinor-2021/_vars.scss b/static/cinor-2021/_vars.scss
new file mode 100644
index 00000000..cd5503d7
--- /dev/null
+++ b/static/cinor-2021/_vars.scss
@@ -0,0 +1,79 @@
+// colors
+$cyan: #46BABA;
+$blue-xdark: #232059;
+$green-blue: #3bb18f;
+$green-blue-dark: #257C63;
+$green-yellow: #d5e50d;
+$green-yellow-light: #d1eaad;
+$gray-light: #eee;
+
+// Fonts-family
+$ff-ss-serif: 'Source Sans Pro', sans-serif;
+$ff-script: 'Dancing Script', 'Brush Script MT', cursive;
+
+$topLinks_height: 2.5rem;
+
+// font sizes
+$fz-small: 0.875em;
+
+// Core vars
+$primary-color: $green-blue;
+$link-color: $green-blue-dark;
+$very-small-limit: 560px;
+$width: 1180px;
+
+$font-family: $ff-ss-serif;
+$font-color: $blue-xdark;
+
+$nav-color: $font-color;
+$nav-background: transparent;
+$nav-active-color: $green-blue-dark;
+$nav-item-hover-background: $font-color;
+$nav-item-hover-color: white;
+$nav-item-selected-background: transparent;
+$nav-item-selected-color: $nav-active-color;
+
+$responsive-menu: left-to-right;
+$nav-menu-side: $topLinks_height;
+$nav-button-background: white;
+$nav-button-color: $primary-color;
+$nav-submenu-background: $font-color;
+$nav-submenu-color: white;
+$nav-mobile-menu-background: $font-color;
+$nav-mobile-menu-item-color: white;
+$nav-mobile-menu-item-hover-color: $green-yellow;
+
+$title-background: transparent;
+$title-weight: 600;
+$title-transform: uppercase;
+$title-font-size: 1.4em;
+$title-color: $font-color;
+
+// $cell-background: #eee;
+$cell-border: none;
+$cell-title-cover-border: false;
+
+$cell-entry-border-color: $green-yellow;
+$cell-entry-hover-background: $green-yellow-light;
+$cell-entry-hover-color: black;
+$cell-entry-hover-effect: bottom-to-top;
+
+$button-background: $primary-color;
+$button-hover-background: $green-blue-dark;
+$button-hover-color: null;
+$widget-unique-checkbox-position: left;
+
+$wcs-step-color: $font-color;
+$wcs-step-border-bottom: none;
+$wcs-step-marker-background: $gray-light;
+$wcs-step-current-marker-color: white;
+$wcs-step-current-marker-background: $primary-color;
+$wcs-steps-spacing: 0.7rem;
+$wcs-step-marker-type: disc;
+
+$buttons-order: previous, cancel, submit;
+
+$footer-background: #0E2327;
+$footer-color: white;
+$footer-link-color: white;
+$footer-menucell-separator: 1px solid $footer-color;
\ No newline at end of file
diff --git a/static/cinor-2021/config.json b/static/cinor-2021/config.json
new file mode 100644
index 00000000..97451a57
--- /dev/null
+++ b/static/cinor-2021/config.json
@@ -0,0 +1,16 @@
+{
+  "label": "La Cinor 2021",
+  "variables": {
+    "theme_color": "#38a58f",
+    "email_header_asset": "emails:logo",
+    "pwa_display": "standalone"
+  },
+  "settings": {
+    "combo": {
+      "COMBO_ASSET_SLOTS.update": {
+        "header:logo": { "label": "Têtière : logo" },
+        "emails:logo": {"label": "Emails : logo"}
+      }
+    }
+  }
+}
diff --git a/static/cinor-2021/style.scss b/static/cinor-2021/style.scss
new file mode 100644
index 00000000..4b0ad16d
--- /dev/null
+++ b/static/cinor-2021/style.scss
@@ -0,0 +1,7 @@
+@charset "UTF-8";
+@import '../includes/fonts/source-sans-pro';
+@import '../includes/fonts/dancing-script';
+
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
diff --git a/templates/variants/cinor-2021/combo/page_template_homepage.html b/templates/variants/cinor-2021/combo/page_template_homepage.html
new file mode 100644
index 00000000..cd871357
--- /dev/null
+++ b/templates/variants/cinor-2021/combo/page_template_homepage.html
@@ -0,0 +1,9 @@
+{% extends "combo/page_template_2cols_sidebar.html" %}
+{% load combo assets i18n %}
+
+{% block before-main-content %}
+  <div class="top-carrousel">
+    {% placeholder "carrousel" name="Carrousel" %}
+  </div>
+  {{ block.super }}
+{% endblock %}
\ No newline at end of file
diff --git a/templates/variants/cinor-2021/combo/wcs/tracking_code_input.html b/templates/variants/cinor-2021/combo/wcs/tracking_code_input.html
new file mode 100644
index 00000000..8b4b805a
--- /dev/null
+++ b/templates/variants/cinor-2021/combo/wcs/tracking_code_input.html
@@ -0,0 +1,5 @@
+{% extends "combo/wcs/tracking_code_input.html" %}
+
+{% block title %}
+<h2 class="script-title">Suivi<small>de votre demande</small></h2>
+{% endblock %}
-- 
2.20.1